Bug 1465987 - [RFE] Change preemption strategy for keepalived failover ip
Summary: [RFE] Change preemption strategy for keepalived failover ip
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Networking
Version: 3.4.0
Hardware: Unspecified
OS: Unspecified
unspecified
urgent
Target Milestone: ---
: 3.7.0
Assignee: Phil Cameron
QA Contact: Meng Bo
URL:
Whiteboard:
: 1466033 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-06-28 15:42 UTC by Steven Walter
Modified: 2017-11-28 21:59 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Feature: ipfailover - Allow admin to set VRRP preemption strategy. See DOCS PR 4674 Reason: Customer request. Result:
Clone Of:
Environment:
Last Closed: 2017-11-28 21:59:33 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Origin (Github) 14947 None None None 2017-06-29 15:42:48 UTC
Red Hat Product Errata RHSA-2017:3188 normal SHIPPED_LIVE Moderate: Red Hat OpenShift Container Platform 3.7 security, bug, and enhancement update 2017-11-29 02:34:54 UTC

Description Steven Walter 2017-06-28 15:42:39 UTC
1. Proposed title of this feature request

change the keepalived failover ip preemption strategy


3. What is the nature and description of the request?

One of the customer observed that if the current primary node(001) goes down, the failover happens and goes to the 2nd node(002), which is perfect!
Now, when the primary node(001) comes back UP, again it failbacks to 001 but we were not expecting that. they want to change the behaviour.


4. Why does the customer need this? (List the business requirements here)

 Causes unbalance -- want minimal fallback

5. How would the customer like to achieve this? (List the functional requirements here)

readonly DEFAULT_PREEMPTION_STRATEGY="nopreempt" 

https://github.com/openshift/origin/blob/master/images/ipfailover/keepalived/lib/config-generators.sh#L16

I see an option to have "nopreempt" which should help to allow above use case. Can we confirm if this will work to be modified?


6. For each functional requirement listed in question 5, specify how Red Hat and the customer can test to confirm the requirement is successfully implemented.

 - Kill node1 to trigger failover
 - Once failed over to node2, bring node1 back up

7. Is there already an existing RFE upstream or in Red Hat bugzilla?

 Unknown

Comment 2 Ben Bennett 2017-06-28 20:09:37 UTC
*** Bug 1466033 has been marked as a duplicate of this bug. ***

Comment 3 Phil Cameron 2017-06-28 20:57:21 UTC
See origin PR 14947

Comment 4 Phil Cameron 2017-06-29 13:05:20 UTC
openshift-docs PR 4674
https://github.com/openshift/openshift-docs/pull/4674

Comment 6 Phil Cameron 2017-06-30 12:52:50 UTC
Origin PR 14947
https://github.com/openshift/origin/pull/14947

Comment 8 openshift-github-bot 2017-07-02 00:57:11 UTC
Commit pushed to master at https://github.com/openshift/origin

https://github.com/openshift/origin/commit/80f1713b8375dfdc523230098434a9eebd93d160
ipfailover - control preempt strategy

This allows the admin to control the VRRP preempt strategy.
The default strategy, preempt_delay <sec>, switches to the higher
priority master after a <sec> (default 300) delay. The second
strategy, nopreempt, suppresses switchin when a higher priority host
becomes available.

The 'oc adm ipfailover --preempt-strategy' option can set the desired
strategy. --preempt-strategy sets the OPENSHIFT_HA_PREEMPTION
environment variable.

bug 1465987
https://bugzilla.redhat.com/show_bug.cgi?id=1465987

openshift docs PR 4674
https://github.com/openshift/openshift-docs/pull/4674

Comment 9 Eric Paris 2017-07-02 01:04:39 UTC
Ignore everything I said to QA...

Comment 11 Meng Bo 2017-07-06 07:23:31 UTC
Tested on OCP v3.6.133, feature has been added.

When creating the ipfailover with option --preemption-strategy="nopreempt" the node in backup state will take the master state and will not enter backup state during the master state node down and up.

Comment 12 openshift-github-bot 2017-07-12 04:50:41 UTC
Commit pushed to master at https://github.com/openshift/openshift-docs

https://github.com/openshift/openshift-docs/commit/240f1b28522e07e314656c72156ee08a249fa79e
ipfailover - control preempt strategy

This allows the admin to control the VRRP preempt strategy.
The default strategy, preempt_delay , switches to the higher
priority master after a (default 300) delay. The second
strategy, nopreempt, suppresses switching when a higher priority host
becomes available.

The 'oc adm ipfailover --preempt-strategy' option can set the desired
strategy. --preempt-strategy sets the OPENSHIFT_HA_PREEMPTION
environment variable.

bug 1465987
https://bugzilla.redhat.com/show_bug.cgi?id=1465987

origin PR 14947
https://github.com/openshift/origin/pull/14947/

Comment 16 errata-xmlrpc 2017-11-28 21:59:33 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2017:3188


Note You need to log in before you can comment on or make changes to this bug.